---
apiVersion: v1
kind: List
items:
- apiVersion: v1
  kind: ConfigMap
  metadata:
    labels:
      funktion.fabric8.io/kind: Connector
      provider: fabric8
      project: connector-docker
      version: 1.1.21
      group: io.fabric8.funktion.connector
    name: docker
  data:
    deployment.yml: |
      ---
      apiVersion: extensions/v1beta1
      kind: Deployment
      metadata:
        labels:
          funktion.fabric8.io/kind: Subscription
          connector: docker
      spec:
        replicas: 1
        template:
          metadata:
            labels:
              funktion.fabric8.io/kind: Subscription
              connector: docker
          spec:
            containers:
            - image: fabric8/connector-docker:1.1.21
              name: connector
    schema.yml: |
      ---
      component:
        kind: component
        scheme: docker
        syntax: docker:operation
        title: Docker
        description: The docker component is used for managing Docker containers.
        label: container,cloud,paas
        deprecated: false
        async: false
        lenientProperties: true
        javaType: org.apache.camel.component.docker.DockerComponent
        groupId: org.apache.camel
        artifactId: camel-docker
        version: 2.18.1
      componentProperties:
        configuration:
          kind: property
          type: object
          javaType: org.apache.camel.component.docker.DockerConfiguration
          deprecated: false
          secret: false
          description: To use the shared docker configuration
      properties:
        operation:
          kind: path
          group: common
          required: true
          type: string
          javaType: org.apache.camel.component.docker.DockerOperation
          enum:
          - events
          - stats
          - auth
          - info
          - ping
          - version
          - imagebuild
          - imagecreate
          - imageinspect
          - imagelist
          - imagepull
          - imagepushimageremove
          - imagesearch
          - imagetag
          - containerattach
          - containercommit
          - containercopyfile
          - containercreate
          - containerdiffinspectcontainer
          - containerkill
          - containerlist
          - containerlog
          - containerpause
          - containerrestart
          - containerremove
          - containerstartcontainerstop
          - containertop
          - containerunpause
          - containerwait
          - execcreate
          - execstart
          deprecated: false
          secret: false
          description: Which operation to use
        email:
          kind: parameter
          group: common
          type: string
          javaType: java.lang.String
          deprecated: false
          secret: false
          description: Email address associated with the user
        host:
          kind: parameter
          group: common
          required: true
          type: string
          javaType: java.lang.String
          deprecated: false
          secret: false
          defaultValue: localhost
          description: Docker host
        port:
          kind: parameter
          group: common
          required: true
          type: integer
          javaType: java.lang.Integer
          deprecated: false
          secret: false
          defaultValue: "2375"
          description: Docker port
        requestTimeout:
          kind: parameter
          group: common
          type: integer
          javaType: java.lang.Integer
          deprecated: false
          secret: false
          description: Request timeout for response (in seconds)
        bridgeErrorHandler:
          kind: parameter
          group: consumer
          label: consumer
          type: boolean
          javaType: boolean
          optionalPrefix: consumer.
          deprecated: false
          secret: false
          defaultValue: false
          description: Allows for bridging the consumer to the Camel routing Error Handler which mean any exceptions occurred while the consumer is trying to pickup incoming messages or the likes will now be processed as a message and handled by the routing Error Handler. By default the consumer will use the org.apache.camel.spi.ExceptionHandler to deal with exceptions that will be logged at WARN/ERROR level and ignored.
        exceptionHandler:
          kind: parameter
          group: consumer (advanced)
          label: consumer,advanced
          type: object
          javaType: org.apache.camel.spi.ExceptionHandler
          optionalPrefix: consumer.
          deprecated: false
          secret: false
          description: To let the consumer use a custom ExceptionHandler. Notice if the option bridgeErrorHandler is enabled then this options is not in use. By default the consumer will deal with exceptions that will be logged at WARN/ERROR level and ignored.
        exchangePattern:
          kind: parameter
          group: consumer (advanced)
          label: consumer,advanced
          type: string
          javaType: org.apache.camel.ExchangePattern
          enum:
          - InOnly
          - RobustInOnly
          - InOut
          - InOptionalOut
          - OutOnly
          - RobustOutOnly
          - OutIn
          - OutOptionalIn
          deprecated: false
          secret: false
          description: Sets the exchange pattern when the consumer creates an exchange.
        followRedirectFilter:
          kind: parameter
          group: advanced
          label: advanced
          type: boolean
          javaType: boolean
          deprecated: false
          secret: false
          defaultValue: false
          description: Whether to follow redirect filter
        loggingFilter:
          kind: parameter
          group: advanced
          label: advanced
          type: boolean
          javaType: boolean
          deprecated: false
          secret: false
          defaultValue: false
          description: Whether to use logging filter
        maxPerRouteConnections:
          kind: parameter
          group: advanced
          label: advanced
          type: integer
          javaType: java.lang.Integer
          deprecated: false
          secret: false
          defaultValue: "100"
          description: Maximum route connections
        maxTotalConnections:
          kind: parameter
          group: advanced
          label: advanced
          type: integer
          javaType: java.lang.Integer
          deprecated: false
          secret: false
          defaultValue: "100"
          description: Maximum total connections
        serverAddress:
          kind: parameter
          group: advanced
          label: advanced
          type: string
          javaType: java.lang.String
          deprecated: false
          secret: false
          defaultValue: https://index.docker.io/v1/
          description: Server address for docker registry.
        socket:
          kind: parameter
          group: advanced
          label: advanced
          type: boolean
          javaType: boolean
          deprecated: false
          secret: false
          defaultValue: true
          description: Socket connection mode
        synchronous:
          kind: parameter
          group: advanced
          label: advanced
          type: boolean
          javaType: boolean
          deprecated: false
          secret: false
          defaultValue: false
          description: Sets whether synchronous processing should be strictly used or Camel is allowed to use asynchronous processing (if supported).
        certPath:
          kind: parameter
          group: security
          label: security
          type: string
          javaType: java.lang.String
          deprecated: false
          secret: false
          description: Location containing the SSL certificate chain
        password:
          kind: parameter
          group: security
          label: security
          type: string
          javaType: java.lang.String
          deprecated: false
          secret: true
          description: Password to authenticate with
        secure:
          kind: parameter
          group: security
          label: security
          type: boolean
          javaType: boolean
          deprecated: false
          secret: false
          defaultValue: false
          description: Use HTTPS communication
        tlsVerify:
          kind: parameter
          group: security
          label: security
          type: boolean
          javaType: boolean
          deprecated: false
          secret: false
          defaultValue: false
          description: Check TLS
        username:
          kind: parameter
          group: security
          label: security
          type: string
          javaType: java.lang.String
          deprecated: false
          secret: true
          description: User name to authenticate with
    documentation.adoc: |
      [[Docker-CamelDockercomponent]]
      Camel Docker component
      ~~~~~~~~~~~~~~~~~~~~~~

      *Available as of Camel 2.15*

      Camel component for communicating with Docker.

      The Docker Camel component leverages the
      https://github.com/docker-java/docker-java[docker-java]??via the
      https://docs.docker.com/reference/api/docker_remote_api[Docker Remote
      API].


      [[Docker-URIformat]]
      URI format
      ^^^^^^^^^^

      [source,java]
      ------------------------------
      docker://[operation]?[options]
      ------------------------------

      Where *operation* is the specific action to perform on Docker.

      [[Docker-Options]]
      General Options
      ^^^^^^^^^^^^^^^

      // component options: START
      The Docker component supports 1 options which are listed below.



      {% raw %}
      [width="100%",cols="2,1m,7",options="header"]
      |=======================================================================
      | Name | Java Type | Description
      | configuration | DockerConfiguration | To use the shared docker configuration
      |=======================================================================
      {% endraw %}
      // component options: END


      // endpoint options: START
      The Docker component supports 20 endpoint options which are listed below:

      {% raw %}
      [width="100%",cols="2,1,1m,1m,5",options="header"]
      |=======================================================================
      | Name | Group | Default | Java Type | Description
      | operation | common |  | DockerOperation | *Required* Which operation to use
      | email | common |  | String | Email address associated with the user
      | host | common | localhost | String | *Required* Docker host
      | port | common | 2375 | Integer | *Required* Docker port
      | requestTimeout | common |  | Integer | Request timeout for response (in seconds)
      | bridgeErrorHandler | consumer | false | boolean | Allows for bridging the consumer to the Camel routing Error Handler which mean any exceptions occurred while the consumer is trying to pickup incoming messages or the likes will now be processed as a message and handled by the routing Error Handler. By default the consumer will use the org.apache.camel.spi.ExceptionHandler to deal with exceptions that will be logged at WARN/ERROR level and ignored.
      | exceptionHandler | consumer (advanced) |  | ExceptionHandler | To let the consumer use a custom ExceptionHandler. Notice if the option bridgeErrorHandler is enabled then this options is not in use. By default the consumer will deal with exceptions that will be logged at WARN/ERROR level and ignored.
      | exchangePattern | consumer (advanced) |  | ExchangePattern | Sets the exchange pattern when the consumer creates an exchange.
      | followRedirectFilter | advanced | false | boolean | Whether to follow redirect filter
      | loggingFilter | advanced | false | boolean | Whether to use logging filter
      | maxPerRouteConnections | advanced | 100 | Integer | Maximum route connections
      | maxTotalConnections | advanced | 100 | Integer | Maximum total connections
      | serverAddress | advanced | https://index.docker.io/v1/ | String | Server address for docker registry.
      | socket | advanced | true | boolean | Socket connection mode
      | synchronous | advanced | false | boolean | Sets whether synchronous processing should be strictly used or Camel is allowed to use asynchronous processing (if supported).
      | certPath | security |  | String | Location containing the SSL certificate chain
      | password | security |  | String | Password to authenticate with
      | secure | security | false | boolean | Use HTTPS communication
      | tlsVerify | security | false | boolean | Check TLS
      | username | security |  | String | User name to authenticate with
      |=======================================================================
      {% endraw %}
      // endpoint options: END

      [[Docker-HeaderStrategy]]
      Header Strategy
      ^^^^^^^^^^^^^^^

      All URI option can be passed as Header properties. Values found in a
      message header take precedence over URI parameters. A header property
      takes the form of a URI option prefixed with *CamelDocker* as shown
      below

      [width="100%",cols="50%,50%",options="header",]
      |=======================================================================
      |URI Option |Header Property

      |containerId |CamelDockerContainerId
      |=======================================================================


      [[Docker-Examples]]
      Examples
      ^^^^^^^^

      The following example consumes events from Docker:

      [source,java]
      ----------------------------------------------------------------------
      from("docker://events?host=192.168.59.103&port=2375").to("log:event");
      ----------------------------------------------------------------------

      The following example queries Docker for system wide information

      [source,java]
      -------------------------------------------------------------------
      from("docker://info?host=192.168.59.103&port=2375").to("log:info");
      -------------------------------------------------------------------


      [[Docker-Dependencies]]
      Dependencies
      ^^^^^^^^^^^^

      To use Docker in your Camel routes you need to add a dependency on
      *camel-docker*, which implements the component.

      If you use Maven you can just add the following to your pom.xml,
      substituting the version number for the latest and greatest release (see
      link:download.html[the download page for the latest versions]).

      [source,java]
      -------------------------------------
      <dependency>
        <groupId>org.apache.camel</groupId>
        <artifactId>camel-docker</artifactId>
        <version>x.x.x</version>
      </dependency>
      -------------------------------------
